<%@ Page Language="C#" AutoEventWireup="true"
	Title="About Member" %>

<%@ Register TagPrefix="cys" Namespace="ChooseYourStory.Web.Controls" Assembly="ChooseYourStory" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="ChooseYourStory.Utilities" %>
<%@ Import Namespace="ChooseYourStory.WebApplication.Data" %>

<script runat="server" language="C#">

    static System.Collections.Generic.List<string> memberTrophyTypes =
        new System.Collections.Generic.List<string>(new[] { "alexp", "chocobot", "EndMaster", "Fleshnblood_78", "Havacoman", "JJJ-thebanisher", "madglee", "march5th00", "Sethaniel", "solostrike", "tsmpaul", "BerkaZerka", "Will11", "mizal", "Killa_Robot", "Gower", "MadHattersDaughter", "ninjapitka" });

    //Get DataTables
    DataTable userInfo = new DataTable();
    DataTable trophies = new DataTable();
    DataTable stories = new DataTable();
    DataTable recentPosts = new DataTable();
    DataTable articles = new DataTable();
    string username;

    protected override void OnPreInit(EventArgs e)
    {
        base.OnPreInit(e);

        username = Request.QueryString["EncodedUsername"];
        if (string.IsNullOrEmpty(username))
        {
            username = Request.QueryString["Username"];
            if (string.IsNullOrEmpty(username)) Response.Redirect("~/");
        }
        else
        {
            username = UrlEncoding.Decode(username);
        }
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        using (SqlCommand cmd = new SqlCommand())
        {
            cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);
            cmd.CommandText = "User_GetProfile";
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("@Username", SqlDbType.VarChar, 30).Value = username;
            try
            {
                cmd.Connection.Open();
                SqlDataReader dr = cmd.ExecuteReader();
                //load the tables
                userInfo.Load(dr);
                trophies.Load(dr);
                stories.Load(dr);
                articles.Load(dr);
                recentPosts.Load(dr);
            }
            finally
            {
                cmd.Connection.Close();
            }

            if (userInfo.Rows.Count == 0) Response.Redirect("~/");
            DataBind();
        }
    }
    string FormatUserRank(object ptObj)
    {
        if (username.ToLower() == "alexp" || username.ToLower() == "march5th00" || username.ToLower() == "chocobot" || username.ToLower() == "cysid")
        {
            return "A Founder of ChooseYourStory.com";
        }
        else if (username.ToLower() == "jjj-thebanisher")
        {
            return " The  &#955;Reader";
        }
        else if (username.ToLower() == "berkazerka")
        {
            return "The Million Word Malkavian";
        }
        else if (username.ToLower() == "endmaster")
        {
            return "The Grandmaster of the Dead";
        }
        else if (username.ToLower() == "killa_robot")
        {
            return "The Grandmaster of Cat Naps";
        }
        else if (username.ToLower() == "mizal")
        {
            return "The Grandmaster Procrastinator";
        }
        else if (username.ToLower() == "will11")
        {
            return "The Grandmaster of History";
        }
        else if (username.ToLower() == "madglee")
        {
            return "23,232,323";
        }
        else
        {
            return "The " + ChooseYourStory.Users.UserRank.FromPointValue((int)ptObj).Title;
        }
    }
    string FormatPointTotal(object ptObj)
    {
        int points = (int)ptObj;
        if (points == 0)
        {
            return "0";
        }
        if (username.ToLower() == "alexp" || username.ToLower() == "march5th00"  || username.ToLower() == "chocobot" || username.ToLower() == "cysid" || username.ToLower() == "madglee" || username.ToLower() == "endmaster" || username.ToLower() == "berkazerka")
            return "infinite";
        else
            return points.ToString("###,###,###,###");
    }
    string FormatEndorsements(object endObj)
    {
        int points = (int)endObj;
        if (points == 0)
        {
            return "0";
        }
        return points.ToString("###,###,###,###");
    }

    string FormatJoinDate(object dteObj)
    {
        if (dteObj == DBNull.Value) return "???";

        DateTime dte = (DateTime)dteObj;
        if (username.ToLower() == "alexp" || username.ToLower() == "march5th00" || username.ToLower() == "chocobot" || username.ToLower() == "cysid")
        {
            return "Beginning of Time";
        }
        else if (dte < new DateTime(2001, 01, 01))
        {
            return "???";
        }
        else
        {
            return dte.ToShortDateString();
        }
    }
    bool GetMessagesAreEnabled(string currentUser, string viewedUser)
    {
        return
            MagDataFactory
                .GetInlineExecutor()
                .ExecuteDataRow(
                    "SELECT * FROM [Users] WHERE ([Username]=@CurrentUser) AND [Private Message Indicator]='Y'",
                    new[] { new SqlParameter("@CurrentUser", currentUser) }) != null &&
            MagDataFactory
                .GetInlineExecutor()
                .ExecuteDataRow(
                    "SELECT * FROM [Users] WHERE ([Username]=@ViewedUser) AND [Private Message Indicator]='Y'",
                    new[] { new SqlParameter("@ViewedUser", viewedUser) }) != null;
    }
</script>

<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" runat="Server">
	<div id="mainContent">
		<h1 style="margin-bottom: 20px;"><span style="font-size:120%"><%#userInfo.Rows[0]["Username"]%></span>, <%#FormatUserRank(userInfo.Rows[0]["Point_Total"])%></h1>
		<div id="profile_Sidebar">
            <asp:PlaceHolder runat="server" Visible='<%# "Y".Equals(userInfo.Rows[0]["Is_Banned"].ToString()) %>'>
                <h1>-BANNED-</h1>
                <asp:PlaceHolder runat="server" Visible='<%# (User.IsInRole(ChooseYourStory.Security.CysRoles.Site_Administrator)) %>'>
                  <a style="display: block; font-size: 80%" href="#" onclick="window.open('/admin/unbanUserPopup.asp?Username=<%#Server.UrlEncode(username)%>','_blank','height=250,width=400,toolbar=no,status=no,location=no,titlebar=no,left=' + (window.screenLeft+100) + ',top=' + (window.screenTop+100));">[Unban user]</a>
                </asp:PlaceHolder>
            </asp:PlaceHolder>	
            <asp:PlaceHolder runat="server" Visible='<%# (User.IsInRole(ChooseYourStory.Security.CysRoles.Site_Administrator)) && !User.Identity.Name.Equals(username) && "N".Equals(userInfo.Rows[0]["Is_Banned"].ToString()) %>'>
                <a style="display: block; font-size: 150%" href="#" onclick="window.open('/admin/banUserPopup.asp?Username=<%#Server.UrlEncode(username)%>','_blank','height=250,width=400,toolbar=no,status=no,location=no,titlebar=no,left=' + (window.screenLeft+100) + ',top=' + (window.screenTop+100));">[Ban user]</a>
            </asp:PlaceHolder>	
			<asp:PlaceHolder runat="server" Visible=<%#userInfo.Rows[0]["Joined_Date"] != DBNull.Value%>>
			<h2>Member Since</h2>
			<div><%#FormatJoinDate(userInfo.Rows[0]["Joined_Date"])%></div>
			</asp:PlaceHolder>
			
			<asp:PlaceHolder runat="server" Visible=<%#userInfo.Rows[0]["LastLogon_Date"] != DBNull.Value%>>
			<h2>Last Activity</h2>
			<div style="font-size: 75%"><%#string.Format("{0:d} {0:t}",userInfo.Rows[0]["LastLogon_Date"])%></div>
			</asp:PlaceHolder>			
			
			<h2>EXP Points</h2>
			<div><a href="/user/points?username=<%#HttpUtility.UrlEncode(userInfo.Rows[0]["Username"].ToString())%>"><%#FormatPointTotal(userInfo.Rows[0]["Point_Total"])%></a></div>
			
			<h2>Post Count</h2>
			<div><%#userInfo.Rows[0]["Post_Count"]%></div>
			
			<h2>Storygame Count</h2>
			<div><%#userInfo.Rows[0]["Story_Count"]%></div>
			
			<h2>Duel Stats</h2>
			<div style="font-size: 75%">
				<%#userInfo.Rows[0]["Won_Duel_Count"]%>
				win<asp:Literal runat="server" Text="s" Visible='<%#userInfo.Rows[0]["Won_Duel_Count"].ToString() != "1" %>' />
				/
				<%#userInfo.Rows[0]["Lost_Duel_Count"]%>
				loss<asp:Literal runat="server" Text="es" Visible='<%#userInfo.Rows[0]["Lost_Duel_Count"].ToString() != "1" %>' />
			</div>

            <h2>Order</h2>
			<div style="font-size: 75%">
				<%#userInfo.Rows[0]["Sect_Prefix"].ToString() + "<a href='/endorsements?sect=" + userInfo.Rows[0]["Sect"].ToString() + "'>" + userInfo.Rows[0]["Sect"].ToString() + "</a>" + userInfo.Rows[0]["Sect_Postfix"].ToString()%>
			</div>

            <h2>Commendations</h2>
			<div><a href="/user/endorsements?username=<%#HttpUtility.UrlEncode(userInfo.Rows[0]["Username"].ToString())%>"><%#FormatEndorsements(userInfo.Rows[0]["Endorsements"])%></a></div>

			<div style="margin-top: 10px;" runat="server" visible='<%# User.Identity.IsAuthenticated %>'>
				<form runat="server">
                    <asp:PlaceHolder runat="server" Visible='<%#GetMessagesAreEnabled(User.Identity.Name, (string)userInfo.Rows[0]["Username"])%>'>
					    <a style="display: block; font-size: 75%" href="/my/messages/new?Username=<%#Server.UrlEncode(username)%>">[send message]</a>
                    </asp:PlaceHolder>
					<asp:PlaceHolder runat="server" Visible='<%# (!userInfo.Rows[0]["Username"].Equals(User.Identity.Name)) && "Y".Equals(userInfo.Rows[0]["DuelsEnabled_Indicator"]) %>'>
						<a style="display: block; font-size: 75%" href="../my/duels/selectDuel.aspx?username=<%#Server.UrlEncode(username)%>">[challenge to duel]</a>
					</asp:PlaceHolder>
					<asp:Hyperlink runat="server" Visible='<%# memberTrophyTypes.Contains(User.Identity.Name) %>' Style="display: block; font-size: 75%" Text="[award personal trophy]" NavigateUrl='<%#"~/members/awardPersonalTrophy.aspx?Username=" + Server.UrlEncode(username)  %>'/>
					<asp:PlaceHolder runat="server" Visible='<%# User.IsInRole(ChooseYourStory.Security.CysRoles.Site_Administrator) %>'>
                        <asp:Hyperlink runat="server" Style="display: block; font-size: 75%" Text="[award admin trophy]" NavigateUrl='<%#"~/members/awardAdminTrophy.aspx?Username=" + Server.UrlEncode(username)  %>'/>
						<a style="display: block; font-size: 75%" href="#" onclick="window.open('/admin/awardPoints.asp?Username=<%#Server.UrlEncode(username)%>','_blank','height=250,width=520,toolbar=no,status=no,location=no,titlebar=no,left=' + (window.screenLeft+100) + ',top=' + (window.screenTop+100));">[admin user]</a>
					</asp:PlaceHolder>
				</form>
			</div>
		</div>
		<div id="profile_Text">
			<img style="float: left; margin-right: 10px;min-width:90px; max-width:600px;" runat="server" src='<%# "~/i/?" + userInfo.Rows[0]["Avatar_Image_Id"].ToString()%>'
				alt="" visible='<%# userInfo.Rows[0]["Avatar_Image_Id"] != DBNull.Value%>' />
			<%#userInfo.Rows[0]["Profile_Text"]%>
		</div>
		<asp:PlaceHolder runat="server" Visible="<%#trophies.Rows.Count>0 %>">
			<div id="profile_Trophies" style="clear:both;">
				<h2>
					Trophies Earned</h2>
				<asp:Repeater runat="server" DataSource="<%#trophies%>">
					<ItemTemplate>
						<asp:Image runat="server" Style="margin: 5px; cursor: pointer; width:50px;height:50px;" ImageUrl='<%# "images/trophies/" + Eval("Image_Name") %>'
							AlternateText='<%#Eval("Trophy_Notes")%>'
                            Title='<%#Eval("Trophy_Notes")%>' onclick="window.open('trophyInfo.htm','trophyInfo','height=400,width=550,scrollbars=yes');" />
					</ItemTemplate>
				</asp:Repeater>
			</div>
		</asp:PlaceHolder>
		<div style="clear:both;height:1px;"></div>
		<asp:PlaceHolder runat="server" Visible="<%#stories.Rows.Count>0 %>">
			<div id="profile_Stories">
				<h1 class="alternate" runat="server">Storygames</h1>
				<asp:Repeater runat="server" DataSource="<%#stories %>">
					<ItemTemplate>
						<div>
							<cys:ThemedImage runat="server" Src="star.gif" Visible='<%# "Y".Equals(Eval("Featured_Indicator")) %>' Alt="Featured Story" />
							<asp:HyperLink runat="server" Visible='<%# Eval("Published_Indicator").Equals("Y") %>' Style="display:inline"
								Text='<%# Eval("Story_Title") %>' NavigateUrl='<%# string.Format("~/story/{0}.aspx",UrlEncoding.Encode(Eval("Story_Title").ToString()))  %>' />
							<span style="font-weight: bold;" runat="server" innertext='<%# Eval("Story_Title") %>'
								visible='<%# Eval("Published_Indicator").Equals("N") %>' />
						</div>
						<div style="font-size: 75%; font-style: italic" runat="server" visible='<%# Eval("Published_Indicator").Equals("N") || Eval("Coauthor_Indicator").Equals("Y") %>'>
							<asp:Literal runat="server" Visible='<%# Eval("Published_Indicator").Equals("N") %>'
								Text="unpublished" />
							<asp:Literal runat="server" Visible='<%# Eval("Published_Indicator").Equals("N") && Eval("Coauthor_Indicator").Equals("Y") %>'
								Text=", " />
							<asp:Literal runat="server" Visible='<%# Eval("Coauthor_Indicator").Equals("Y") %>'
								Text="coauthor" />
						</div>
						<div style="margin-bottom: 10px;" runat="server" innerhtml='<%# System.Web.HttpUtility.HtmlDecode(Eval("Story_Description").ToString().Replace("<style","").Replace("<body","").Replace("<iframe","").Replace("<script","")) %>' />
                        <hr />
					</ItemTemplate>
				</asp:Repeater>
			</div>
		</asp:PlaceHolder>
		<asp:PlaceHolder runat="server" Visible="<%#articles.Rows.Count>0 %>">
			<div id="profile_Articles">
				<h1 class="alternate">
					Articles Written</h1>
				<asp:Repeater runat="server" DataSource="<%#articles %>">
					<ItemTemplate>
						<asp:HyperLink runat="server" Text='<%# Eval("Article_Title") %>' NavigateUrl='<%# "~/help/articles/article.aspx?ArticleId=" + Eval("Article_Id") %>' />
						<div runat="server" style="margin-bottom: 10px;" innerhtml='<%# System.Web.HttpUtility.HtmlDecode(Eval("Article_Description").ToString().Replace("<style","").Replace("<body","").Replace("<iframe","").Replace("<script","")) %>' />
                        <hr />
					</ItemTemplate>
				</asp:Repeater>
			</div>
		</asp:PlaceHolder>
		<asp:PlaceHolder runat="server" Visible="<%#recentPosts.Rows.Count > 0 %>">
			<div id="profile_Posts">
				<h1 class="alternate">
					Recent Posts</h1>
				<asp:Repeater runat="server" DataSource="<%#recentPosts %>">
					<ItemTemplate>
					    <asp:HyperLink runat="server" Text='<%# Eval("Post_Title") %>' NavigateUrl='<%# "../forums/message.aspx?MessageId=" + Eval("Message_Id") + "#" + Eval("Post_Id") %>' />
					    <span runat="server" style="font-size: 75%; font-style: italic;" innertext='<%# " on " + Eval("Post_Date") %>' />
					    <div runat="server" style="margin-bottom: 10px;" innerhtml='<%# System.Web.HttpUtility.HtmlDecode(Eval("Body_Text").ToString().Replace("<style","").Replace("<body","").Replace("<iframe","").Replace("<script","")) %>' />
                        <hr />
					</ItemTemplate>
				</asp:Repeater>
			</div>
		</asp:PlaceHolder>
	</div>
	<cys:AspPage ID="AspPage1" runat="server" Url="~/Includes/footer.asp" />
</asp:Content>
