Class Duel

	Public DuelId, DuelType, DuelDate, ChallengerUsername, ChallengeeUsername
	Public Status, Wager, ChallengerChoice, ChallengeeChoice, Winner

	Public m_ErrorMessage
	Public Property Get ErrorMessage
		ErrorMessage = m_ErrorMessage
	End Property
	
	Sub LoadFromForm(frm)
		 ChallengerUsername = Session("Username")
		 ChallengeeUsername = frm("ChallengeeUsername")
		 Wager = frm("Wager")
		 ChallengerChoice = frm("ChallengerChoice")
	End Sub
	
	Function Load( DuelId )
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Application("ConnectionString")
			.CommandText = _
				"SELECT [Duel Id], [Duel Type], [Duel Date], [Challenger Username], [Challengee Username], " & _
				"       [Challenger Choice], [Challengee Choice], [Status], [Winner], [Wager] " & _
				"  FROM [Duels] WHERE [Duel Id] = ? "
			.Parameters.Append .CreateParameter("Duel Id", adInteger, adParamInput, 4, DuelId)
			With .Execute
				If .EOF Then : Load = False : Exit Function : End If
				Me.DuelId = .Fields("Duel Id").Value				
				DuelType = .Fields("Duel Type").Value
				DuelDate = .Fields("Duel Date").Value
				ChallengerUsername = .Fields("Challenger Username").Value
				ChallengeeUsername = .Fields("Challengee Username").Value
				ChallengerChoice = .Fields("Challenger Choice").Value
				ChallengeeChoice = .Fields("Challengee Choice").Value
				Status = .Fields("Status").Value
				Winner = .Fields("Winner").Value
				Wager = .Fields("Wager").Value
			End With
		End With
		Load = True	
	End Function

	Public Function Accept
		Dim cmd : Set cmd = Server.CreateObject("ADODB.Command")
		With cmd
			.ActiveConnection = Application("ConnectionString")
			.CommandText = "[Accept Duel Challenge]"
			.CommandType = adCmdStoredProc
			.Parameters.Append .CreateParameter("DuelId", adInteger, adParamInput, 4, DuelId)			
			.Parameters.Append .CreateParameter("ChallengeeChoice", adVarChar, adParamInput, 50, ChallengeeChoice)
			.Parameters.Append .CreateParameter("Winner", adVarChar, adParamInput, 10, Winner)
			Accept = TryExecute(cmd)
		End With		
	End Function
	
	Public Function Decline
		Dim cmd : Set cmd = Server.CreateObject("ADODB.Command")
		With cmd
			.ActiveConnection = Application("ConnectionString")
			.CommandText = "[Decline Duel Challenge]"
			.CommandType = adCmdStoredProc
			.Parameters.Append .CreateParameter("DuelId", adInteger, adParamInput, 4, DuelId)			
			Decline = TryExecute(cmd)
		End With		
	End Function	
		
	Public Function IssueChallenge
		Dim cmd : Set cmd = Server.CreateObject("ADODB.Command")
		With cmd
			.ActiveConnection = Application("ConnectionString")
			.CommandText = "[Issue Duel Challenge]"
			.CommandType = adCmdStoredProc
			.Parameters.Append .CreateParameter("ChallengeType", adVarChar, adParamInput, 50, DuelType)
			.Parameters.Append .CreateParameter("ChallengerUsername", adVarChar, adParamInput, 20, ChallengerUsername)
			.Parameters.Append .CreateParameter("ChallengeeUsername", adVarChar, adParamInput, 20, ChallengeeUsername)
			.Parameters.Append .CreateParameter("Wager", adInteger, adParamInput, 4, Wager)			
			.Parameters.Append .CreateParameter("ChallengerChoice", adVarChar, adParamInput, 50, ChallengerChoice)
			.Parameters.Append .CreateParameter("DuelId", adInteger, adParamOutput, 4)
			IssueChallenge = TryExecute(cmd)
			DuelId = .Parameters("DuelId").Value
		End With
	End Function

	
	Private Function TryExecute(cmd)
		TryExecute = True

		On Error Resume Next
		cmd.Execute
		If Err.Number = 0 Then Exit Function
		On Error Goto 0
		
		Dim Conn : Set Conn = cmd.ActiveConnection

		Dim sqlErr : For Each sqlErr In Conn.Errors
			Select Case sqlErr.NativeError
				Case 0 
					'just a debug message, ignore
				Case 50000
					'user definied
					m_ErrorMessage = Replace(sqlErr.Description,"[Microsoft][ODBC SQL Server Driver][SQL Server]","")
					TryExecute = False
				Case Else
					m_ErrorMessage = _
						"Error#" & sqlErr.Number & " in " & sqlErr.Source & ": " & sqlErr.Description
					TryExecute = False
					Err.Raise sqlErr.Number, sqlErr.Source, sqlErr.Description
			End Select
		Next
	End Function	

End Class